# Source Generated with Decompyle++
# File: in.pyo (Python 2.3)

__version__ = ' $Id: paraparser.py,v 1.54 2004/01/20 22:50:32 andy_robinson Exp $ '
import string
import re
from types import TupleType
import sys
import os
import copy
import reportlab.lib.sequencer as reportlab
from reportlab.lib.abag import ABag

try:
    from reportlab.lib import xmllib
    _xmllib_newStyle = 1
except ImportError:
    import xmllib
    _xmllib_newStyle = 0

from reportlab.lib.colors import toColor, white, black, red, Color
from reportlab.lib.fonts import tt2ps, ps2tt
from reportlab.lib.enums import TA_LEFT, TA_RIGHT, TA_CENTER, TA_JUSTIFY
from reportlab.lib.units import inch, mm, cm, pica
_re_para = re.compile('^\\s*<\\s*para(\\s+|>)')
sizeDelta = 2
subFraction = 0.5
superFraction = 0.5

def _num(s, unit = 1):
    """Convert a string like '10cm' to an int or float (in points).
       The default unit is point, but optionally you can use other
       default units like mm.
    """
    if s[-2:] == 'cm':
        unit = cm
        s = s[:-2]
    
    if s[-2:] == 'in':
        unit = inch
        s = s[:-2]
    
    if s[-2:] == 'pt':
        unit = 1
        s = s[:-2]
    
    if s[-1:] == 'i':
        unit = inch
        s = s[:-1]
    
    if s[-2:] == 'mm':
        unit = mm
        s = s[:-2]
    
    if s[-4:] == 'pica':
        unit = pica
        s = s[:-4]
    
    if s[0] in [
        '+',
        '-']:
        
        try:
            return ('relative', int(s) * unit)
        except ValueError:
            return ('relative', float(s) * unit)
        except:
            None<EXCEPTION MATCH>ValueError
        

    None<EXCEPTION MATCH>ValueError
    
    try:
        return int(s) * unit
    except ValueError:
        return float(s) * unit



def _align(s):
    s = string.lower(s)
    if s == 'left':
        return TA_LEFT
    elif s == 'right':
        return TA_RIGHT
    elif s == 'justify':
        return TA_JUSTIFY
    elif s in ('centre', 'center'):
        return TA_CENTER
    else:
        raise ValueError

_paraAttrMap = {
    'font': ('fontName', None),
    'face': ('fontName', None),
    'fontsize': ('fontSize', _num),
    'size': ('fontSize', _num),
    'leading': ('leading', _num),
    'lindent': ('leftIndent', _num),
    'rindent': ('rightIndent', _num),
    'findent': ('firstLineIndent', _num),
    'align': ('alignment', _align),
    'spaceb': ('spaceBefore', _num),
    'spacea': ('spaceAfter', _num),
    'bfont': ('bulletFontName', None),
    'bfontsize': ('bulletFontSize', _num),
    'bindent': ('bulletIndent', _num),
    'bcolor': ('bulletColor', toColor),
    'color': ('textColor', toColor),
    'backcolor': ('backColor', toColor),
    'bgcolor': ('backColor', toColor),
    'bg': ('backColor', toColor),
    'fg': ('textColor', toColor) }
_bulletAttrMap = {
    'font': ('bulletFontName', None),
    'face': ('bulletFontName', None),
    'size': ('bulletFontSize', _num),
    'fontsize': ('bulletFontSize', _num),
    'indent': ('bulletIndent', _num),
    'color': ('bulletColor', toColor),
    'fg': ('bulletColor', toColor) }
_fontAttrMap = {
    'size': ('fontSize', _num),
    'face': ('fontName', None),
    'name': ('fontName', None),
    'fg': ('textColor', toColor),
    'color': ('textColor', toColor) }

def _addAttributeNames(m):
    K = m.keys()
    for k in K:
        n = m[k][0]
        if not m.has_key(n):
            m[n] = m[k]
        
        n = string.lower(n)
        if not m.has_key(n):
            m[n] = m[k]
            continue
    

_addAttributeNames(_paraAttrMap)
_addAttributeNames(_fontAttrMap)
_addAttributeNames(_bulletAttrMap)

def _applyAttributes(obj, attr):
    for k, v in attr.items():
        if type(v) is TupleType and v[0] == 'relative':
            if hasattr(obj, k):
                v = v[1] + getattr(obj, k)
            else:
                v = v[1]
        
        setattr(obj, k, v)
    

greeks = {
    'Alpha': 'A',
    'Beta': 'B',
    'Chi': 'C',
    'Delta': 'D',
    'Epsilon': 'E',
    'Eta': 'H',
    'Gamma': 'G',
    'Iota': 'I',
    'Kappa': 'K',
    'Lambda': 'L',
    'Mu': 'M',
    'Nu': 'N',
    'Omega': 'W',
    'Omicron': 'O',
    'Phi': 'F',
    'Pi': 'P',
    'Psi': 'Y',
    'Rho': 'R',
    'Sigma': 'S',
    'Tau': 'T',
    'Theta': 'Q',
    'Upsilon': 'U',
    'Xi': 'X',
    'Zeta': 'Z',
    'alefsym': '\xc0',
    'alpha': 'a',
    'and': '\xd9',
    'ang': '\xd0',
    'asymp': '\xbb',
    'beta': 'b',
    'bull': '\xb7',
    'cap': '\xc7',
    'chi': 'c',
    'clubs': '\xa7',
    'cong': '@',
    'cup': '\xc8',
    'dArr': '\xdf',
    'darr': '\xaf',
    'delta': 'd',
    'diams': '\xa8',
    'empty': '\xc6',
    'epsilon': 'e',
    'epsiv': 'e',
    'equiv': '\xba',
    'eta': 'h',
    'euro': '\xa0',
    'exist': '$',
    'forall': '"',
    'frasl': '\xa4',
    'gamma': 'g',
    'ge': '\xb3',
    'hArr': '\xdb',
    'harr': '\xab',
    'hearts': '\xa9',
    'hellip': '\xbc',
    'image': '\xc1',
    'infin': '\xa5',
    'int': '\xf2',
    'iota': 'i',
    'isin': '\xce',
    'kappa': 'k',
    'lArr': '\xdc',
    'lambda': 'l',
    'lang': '\xe1',
    'larr': '\xac',
    'lceil': '\xe9',
    'le': '\xa3',
    'lfloor': '\xeb',
    'lowast': '*',
    'loz': '\xe0',
    'minus': '-',
    'mu': 'm',
    'nabla': '\xd1',
    'ne': '\xb9',
    'ni': "'",
    'notin': '\xcf',
    'nsub': '\xcb',
    'nu': 'n',
    'oline': '`',
    'omega': 'w',
    'omicron': 'o',
    'oplus': '\xc5',
    'or': '\xda',
    'otimes': '\xc4',
    'part': '\xb6',
    'perp': '^',
    'phi': 'j',
    'phis': 'f',
    'pi': 'p',
    'piv': 'v',
    'prime': '\xa2',
    'prod': '\xd5',
    'prop': '\xb5',
    'psi': 'y',
    'rArr': '\xde',
    'radic': '\xd6',
    'rang': '\xf1',
    'rarr': '\xae',
    'rceil': '\xf9',
    'real': '\xc2',
    'rfloor': '\xfb',
    'rho': 'r',
    'sdot': '\xd7',
    'sigma': 's',
    'sigmaf': 'V',
    'sigmav': 'V',
    'sim': '~',
    'spades': '\xaa',
    'sub': '\xcc',
    'sube': '\xcd',
    'sum': '\xe5',
    'sup': '\xc9',
    'supe': '\xca',
    'tau': 't',
    'there4': '\\',
    'theta': 'q',
    'thetasym': 'J',
    'thetav': 'J',
    'trade': '\xe4',
    'uArr': '\xdd',
    'uarr': '\xad',
    'upsih': '\xa1',
    'upsilon': 'u',
    'weierp': '\xc3',
    'xi': 'x',
    'zeta': 'z' }
symenc = {
    913: 'A',
    914: 'B',
    915: 'G',
    916: 'D',
    917: 'E',
    918: 'Z',
    919: 'H',
    920: 'Q',
    921: 'I',
    922: 'K',
    923: 'L',
    924: 'M',
    925: 'N',
    926: 'X',
    927: 'O',
    928: 'P',
    929: 'R',
    931: 'S',
    932: 'T',
    933: 'U',
    934: 'F',
    935: 'C',
    936: 'Y',
    937: 'W',
    945: 'a',
    946: 'b',
    947: 'g',
    948: 'd',
    949: 'e',
    950: 'z',
    951: 'h',
    952: 'q',
    953: 'i',
    954: 'k',
    955: 'l',
    956: 'm',
    957: 'n',
    958: 'x',
    959: 'o',
    960: 'p',
    961: 'r',
    962: 'V',
    963: 's',
    964: 't',
    965: 'u',
    966: 'j',
    967: 'c',
    968: 'y',
    969: 'w',
    977: 'J',
    978: '\xa1',
    981: 'f',
    982: 'v',
    8704: '"',
    8706: '\xb6',
    8707: '$',
    8709: '\xc6',
    8711: '\xd1',
    8712: '\xce',
    8713: '\xcf',
    8715: "'",
    8719: '\xd5',
    8721: '\xe5',
    8722: '-',
    8727: '*',
    8730: '\xd6',
    8733: '\xb5',
    8734: '\xa5',
    8736: '\xd0',
    8869: '\xd9',
    8870: '\xda',
    8745: '\xc7',
    8746: '\xc8',
    8747: '\xf2',
    8756: '\\',
    8764: '~',
    8773: '@',
    8776: '\xbb',
    8800: '\xb9',
    8801: '\xba',
    8804: '\xa3',
    8805: '\xb3',
    8834: '\xcc',
    8835: '\xc9',
    8836: '\xcb',
    8838: '\xcd',
    8839: '\xca',
    8853: '\xc5',
    8855: '\xc4',
    8869: '^',
    8901: '\xd7',
    9674: '\xe0',
    8968: '\xe9',
    8969: '\xf9',
    8970: '\xeb',
    8971: '\xfb',
    9001: '\xe1',
    9002: '\xf1',
    8592: '\xac',
    8593: '\xad',
    8594: '\xae',
    8595: '\xaf',
    8596: '\xab',
    8656: '\xdc',
    8657: '\xdd',
    8658: '\xde',
    8659: '\xdf',
    8660: '\xdb',
    8226: '\xb7',
    8230: '\xbc',
    8242: '\xa2',
    8254: '`',
    8260: '\xa4',
    8472: '\xc3',
    8465: '\xc1',
    8476: '\xc2',
    8482: '\xe4',
    8364: '\xa0',
    8501: '\xc0',
    9824: '\xaa',
    9827: '\xa7',
    9829: '\xa9',
    9830: '\xa8' }

class ParaFrag(ABag):
    '''class ParaFrag contains the intermediate representation of string
    segments as they are being parsed by the XMLParser.
    fontname, fontSize, rise, textColor, cbDefn
    '''
    pass


class ParaParser(xmllib.XMLParser):
    
    def __getattr__(self, attrName):
        '''This way we can handle <TAG> the same way as <tag> (ignoring case).'''
        if attrName != attrName.lower() and attrName != 'caseSensitive' and not (self.caseSensitive):
            if attrName[:6] == 'start_':
                return eval('self.' + attrName.lower())
            
            if attrName[:4] == 'end_':
                return eval('self.' + attrName.lower())
            
        
        raise AttributeError, attrName

    
    def start_b(self, attributes):
        self._push(bold = 1)

    
    def end_b(self):
        self._pop(bold = 1)

    
    def start_strong(self, attributes):
        self._push(bold = 1)

    
    def end_strong(self):
        self._pop(bold = 1)

    
    def start_i(self, attributes):
        self._push(italic = 1)

    
    def end_i(self):
        self._pop(italic = 1)

    
    def start_em(self, attributes):
        self._push(italic = 1)

    
    def end_em(self):
        self._pop(italic = 1)

    
    def start_u(self, attributes):
        self._push(underline = 1)

    
    def end_u(self):
        self._pop(underline = 1)

    
    def start_super(self, attributes):
        self._push(super = 1)

    
    def end_super(self):
        self._pop(super = 1)

    if _xmllib_newStyle:
        start_sup = start_super
        end_sup = end_super
    
    
    def start_sub(self, attributes):
        self._push(sub = 1)

    
    def end_sub(self):
        self._pop(sub = 1)

    if _xmllib_newStyle:
        
        def handle_charref(self, name):
            
            try:
                if name[0] == 'x':
                    n = string.atoi(name[1:], 16)
                else:
                    n = string.atoi(name)
            except string.atoi_error:
                self.unknown_charref(name)
                return None

            if n <= n:
                pass
            elif n <= 255:
                self.handle_data(chr(n))
            elif symenc.has_key(n):
                self._push(greek = 1)
                self.handle_data(symenc[n])
                self._pop(greek = 1)
            else:
                self.unknown_charref(name)

        
        def handle_entityref(self, name):
            if greeks.has_key(name):
                self._push(greek = 1)
                self.handle_data(greeks[name])
                self._pop(greek = 1)
            else:
                xmllib.XMLParser.handle_entityref(self, name)

        
        def syntax_error(self, lineno, message):
            self._syntax_error(message)

    else:
        
        def start_greekLetter(self, attributes, letter):
            self._push(greek = 1)
            self.handle_data(letter)

        
        def syntax_error(self, message):
            self._syntax_error(message)

    
    def _syntax_error(self, message):
        if message[:10] == 'attribute ' and message[-17:] == ' value not quoted':
            return None
        
        self.errors.append(message)

    
    def start_greek(self, attributes):
        self._push(greek = 1)

    
    def end_greek(self):
        self._pop(greek = 1)

    
    def start_font(self, attr):
        apply(self._push, (), self.getAttributes(attr, _fontAttrMap))

    
    def end_font(self):
        self._pop()

    
    def _initial_frag(self, attr, attrMap, bullet = 0):
        style = self._style
        if attr != { }:
            style = copy.deepcopy(style)
            _applyAttributes(style, self.getAttributes(attr, attrMap))
            self._style = style
        
        frag = ParaFrag()
        frag.sub = 0
        frag.super = 0
        frag.rise = 0
        frag.underline = 0
        frag.greek = 0
        if bullet:
            (frag.fontName, frag.bold, frag.italic) = ps2tt(style.bulletFontName)
            frag.fontSize = style.bulletFontSize
            if not hasattr(style, 'bulletColor') and style.bulletColor:
                pass
            frag.textColor = style.textColor
        else:
            (frag.fontName, frag.bold, frag.italic) = ps2tt(style.fontName)
            frag.fontSize = style.fontSize
            frag.textColor = style.textColor
        return frag

    
    def start_para(self, attr):
        self._stack = [
            self._initial_frag(attr, _paraAttrMap)]

    
    def end_para(self):
        self._pop()

    
    def start_bullet(self, attr):
        if hasattr(self, 'bFragList'):
            self._syntax_error('only one <bullet> tag allowed')
        
        self.bFragList = []
        frag = self._initial_frag(attr, _bulletAttrMap, 1)
        frag.isBullet = 1
        self._stack.append(frag)

    
    def end_bullet(self):
        self._pop()

    
    def start_seqdefault(self, attr):
        
        try:
            default = attr['id']
        except KeyError:
            default = None

        self._seq.setDefaultCounter(default)

    
    def end_seqdefault(self):
        pass

    
    def start_seqreset(self, attr):
        
        try:
            id = attr['id']
        except KeyError:
            id = None

        
        try:
            base = math.atoi(attr['base'])
        except:
            base = 0

        self._seq.reset(id, base)

    
    def end_seqreset(self):
        pass

    
    def start_seqDefault(self, attr):
        self.start_seqdefault(attr)

    
    def end_seqDefault(self):
        self.end_seqdefault()

    
    def start_seqReset(self, attr):
        self.start_seqreset(attr)

    
    def end_seqReset(self):
        self.end_seqreset()

    
    def start_seq(self, attr):
        if attr.has_key('template'):
            templ = attr['template']
            self.handle_data(templ % self._seq)
            return None
        elif attr.has_key('id'):
            id = attr['id']
        else:
            id = None
        output = self._seq.nextf(id)
        self.handle_data(output)

    
    def end_seq(self):
        pass

    
    def start_onDraw(self, attr):
        defn = ABag()
        if attr.has_key('name'):
            defn.name = attr['name']
        else:
            self._syntax_error('<onDraw> needs at least a name attribute')
        if attr.has_key('label'):
            defn.label = attr['label']
        
        defn.kind = 'onDraw'
        self._push(cbDefn = defn)
        self.handle_data('')
        self._pop()

    
    def _push(self, **attr):
        frag = copy.copy(self._stack[-1])
        _applyAttributes(frag, attr)
        self._stack.append(frag)

    
    def _pop(self, **kw):
        frag = self._stack[-1]
        del self._stack[-1]
        for k, v in kw.items():
            pass
        
        return frag

    
    def getAttributes(self, attr, attrMap):
        A = { }
        for k, v in attr.items():
            if not (self.caseSensitive):
                k = string.lower(k)
            
            if k in attrMap.keys():
                j = attrMap[k]
                func = j[1]
                
                try:
                    if not func is None and v:
                        pass
                    A[j[0]] = apply(func, (v,))
                self._syntax_error('%s: invalid value %s' % (k, v))

                continue
            self._syntax_error('invalid attribute name %s' % k)
        
        return A

    
    def __init__(self, verbose = 0):
        self.caseSensitive = 0
        if _xmllib_newStyle:
            xmllib.XMLParser.__init__(self, verbose = verbose)
        else:
            xmllib.XMLParser.__init__(self)
            self.elements = {
                'b': (self.start_b, self.end_b),
                'strong': (self.start_b, self.end_b),
                'u': (self.start_u, self.end_u),
                'i': (self.start_i, self.end_i),
                'em': (self.start_i, self.end_i),
                'super': (self.start_super, self.end_super),
                'sup': (self.start_super, self.end_super),
                'sub': (self.start_sub, self.end_sub),
                'font': (self.start_font, self.end_font),
                'greek': (self.start_greek, self.end_greek),
                'para': (self.start_para, self.end_para) }
            for item in greeks.keys():
                self.elements[item] = ((lambda attr, self = self, letter = greeks[item]: self.start_greekLetter(attr, letter)), self.end_greek)
            
            self.entitydefs = self.entitydefs.copy()
            for item in greeks.keys():
                self.entitydefs[item] = '<%s/>' % item
            

    
    def _iReset(self):
        self.fragList = []
        if hasattr(self, 'bFragList'):
            delattr(self, 'bFragList')
        

    
    def _reset(self, style):
        '''reset the parser'''
        xmllib.XMLParser.reset(self)
        self.errors = []
        self._style = style
        self._iReset()

    
    def handle_data(self, data):
        '''Creates an intermediate representation of string segments.'''
        frag = copy.copy(self._stack[-1])
        if hasattr(frag, 'cbDefn'):
            if data != '':
                syntax_error('Only <onDraw> tag allowed')
            
        elif frag.sub == 1 and frag.super == 1:
            frag.sub = 0
            frag.super = 0
        
        if frag.sub:
            frag.rise = -(frag.fontSize) * subFraction
            frag.fontSize = max(frag.fontSize - sizeDelta, 3)
        elif frag.super:
            frag.rise = frag.fontSize * superFraction
            frag.fontSize = max(frag.fontSize - sizeDelta, 3)
        
        if frag.greek:
            frag.fontName = 'symbol'
        
        x = frag.fontName = tt2ps(frag.fontName, frag.bold, frag.italic)
        frag.text = data
        if hasattr(frag, 'isBullet'):
            delattr(frag, 'isBullet')
            self.bFragList.append(frag)
        else:
            self.fragList.append(frag)

    
    def handle_cdata(self, data):
        self.handle_data(data)

    
    def parse(self, text, style):
        '''Given a formatted string will return a list of
        ParaFrag objects with their calculated widths.
        If errors occur None will be returned and the
        self.errors holds a list of the error messages.
        '''
        self._seq = reportlab.lib.sequencer.getSequencer()
        self._reset(style)
        if len(text) >= 6 and text[0] == '<':
            pass
        if not _re_para.match(text):
            text = '<para>' + text + '</para>'
        
        self.feed(text)
        self.close()
        del self._seq
        style = self._style
        del self._style
        if len(self.errors) == 0:
            fragList = self.fragList
            if not hasattr(self, 'bFragList') and self.bFragList:
                pass
            bFragList = None
            self._iReset()
        else:
            fragList = bFragList = None
        return (style, fragList, bFragList)


if __name__ == '__main__':
    from reportlab.platypus import cleanBlockQuotedText
    _parser = ParaParser()
    
    def check_text(text, p = _parser):
        print '##########'
        text = cleanBlockQuotedText(text)
        (l, rv, bv) = p.parse(text, style)
        if rv is None:
            for l in _parser.errors:
                print l
            
        else:
            print 'ParaStyle', l.fontName, l.fontSize, l.textColor
            for l in rv:
                print l.fontName, l.fontSize, l.textColor, l.bold, l.rise, '|%s|' % l.text[:25],
                if hasattr(l, 'cbDefn'):
                    print 'cbDefn', l.cbDefn.name, l.cbDefn.label, l.cbDefn.kind
                    continue
                print 
            

    style = ParaFrag()
    style.fontName = 'Times-Roman'
    style.fontSize = 12
    style.textColor = black
    style.bulletFontName = black
    style.bulletFontName = 'Times-Roman'
    style.bulletFontSize = 12
    text = '\n    <b><i><greek>a</greek>D</i></b>&beta;\n    <font name="helvetica" size="15" color=green>\n    Tell me, O muse, of that ingenious hero who travelled far and wide\n    after</font> he had sacked the famous town of Troy. Many cities did he visit,\n    and many were the nations with whose manners and customs he was acquainted;\n    moreover he suffered much by sea while trying to save his own life\n    and bring his men safely home; but do what he might he could not save\n    his men, for they perished through their own sheer folly in eating\n    the cattle of the Sun-god Hyperion; so the god prevented them from\n    ever reaching home. Tell me, too, about all these things, O daughter\n    of Jove, from whatsoever source you<super>1</super> may know them.\n    '
    check_text(text)
    check_text('<para> </para>')
    check_text('<para font="times-bold" size=24 leading=28.8 spaceAfter=72>ReportLab -- Reporting for the Internet Age</para>')
    check_text('\n    <font color=red>&tau;</font>Tell me, O muse, of that ingenious hero who travelled far and wide\n    after he had sacked the famous town of Troy. Many cities did he visit,\n    and many were the nations with whose manners and customs he was acquainted;\n    moreover he suffered much by sea while trying to save his own life\n    and bring his men safely home; but do what he might he could not save\n    his men, for they perished through their own sheer folly in eating\n    the cattle of the Sun-god Hyperion; so the god prevented them from\n    ever reaching home. Tell me, too, about all these things, O daughter\n    of Jove, from whatsoever source you may know them.')
    check_text('\n    Telemachus took this speech as of good omen and rose at once, for\n    he was bursting with what he had to say. He stood in the middle of\n    the assembly and the good herald Pisenor brought him his staff. Then,\n    turning to Aegyptius, "Sir," said he, "it is I, as you will shortly\n    learn, who have convened you, for it is I who am the most aggrieved.\n    I have not got wind of any host approaching about which I would warn\n    you, nor is there any matter of public moment on which I would speak.\n    My grieveance is purely personal, and turns on two great misfortunes\n    which have fallen upon my house. The first of these is the loss of\n    my excellent father, who was chief among all you here present, and\n    was like a father to every one of you; the second is much more serious,\n    and ere long will be the utter ruin of my estate. The sons of all\n    the chief men among you are pestering my mother to marry them against\n    her will. They are afraid to go to her father Icarius, asking him\n    to choose the one he likes best, and to provide marriage gifts for\n    his daughter, but day by day they keep hanging about my father\'s house,\n    sacrificing our oxen, sheep, and fat goats for their banquets, and\n    never giving so much as a thought to the quantity of wine they drink.\n    No estate can stand such recklessness; we have now no Ulysses to ward\n    off harm from our doors, and I cannot hold my own against them. I\n    shall never all my days be as good a man as he was, still I would\n    indeed defend myself if I had power to do so, for I cannot stand such\n    treatment any longer; my house is being disgraced and ruined. Have\n    respect, therefore, to your own consciences and to public opinion.\n    Fear, too, the wrath of heaven, lest the gods should be displeased\n    and turn upon you. I pray you by Jove and Themis, who is the beginning\n    and the end of councils, [do not] hold back, my friends, and leave\n    me singlehanded- unless it be that my brave father Ulysses did some\n    wrong to the Achaeans which you would now avenge on me, by aiding\n    and abetting these suitors. Moreover, if I am to be eaten out of house\n    and home at all, I had rather you did the eating yourselves, for I\n    could then take action against you to some purpose, and serve you\n    with notices from house to house till I got paid in full, whereas\n    now I have no remedy."')
    check_text('\nBut as the sun was rising from the fair sea into the firmament of\nheaven to shed light on mortals and immortals, they reached Pylos\nthe city of Neleus. Now the people of Pylos were gathered on the sea\nshore to offer sacrifice of black bulls to Neptune lord of the Earthquake.\nThere were nine guilds with five hundred men in each, and there were\nnine bulls to each guild. As they were eating the inward meats and\nburning the thigh bones [on the embers] in the name of Neptune, Telemachus\nand his crew arrived, furled their sails, brought their ship to anchor,\nand went ashore. ')
    check_text('\nSo the neighbours and kinsmen of Menelaus were feasting and making\nmerry in his house. There was a bard also to sing to them and play\nhis lyre, while two tumblers went about performing in the midst of\nthem when the man struck up with his tune.]')
    check_text('\n"When we had passed the [Wandering] rocks, with Scylla and terrible\nCharybdis, we reached the noble island of the sun-god, where were\nthe goodly cattle and sheep belonging to the sun Hyperion. While still\nat sea in my ship I could bear the cattle lowing as they came home\nto the yards, and the sheep bleating. Then I remembered what the blind\nTheban prophet Teiresias had told me, and how carefully Aeaean Circe\nhad warned me to shun the island of the blessed sun-god. So being\nmuch troubled I said to the men, \'My men, I know you are hard pressed,\nbut listen while I tell you the prophecy that Teiresias made me, and\nhow carefully Aeaean Circe warned me to shun the island of the blessed\nsun-god, for it was here, she said, that our worst danger would lie.\nHead the ship, therefore, away from the island.')
    check_text('A&lt;B&gt;C&amp;D&quot;E&apos;F')
    check_text('A&lt; B&gt; C&amp; D&quot; E&apos; F')
    check_text('<![CDATA[<>&\'"]]>')
    check_text('<bullet face=courier size=14 color=green>+</bullet>\nThere was a bard also to sing to them and play\nhis lyre, while two tumblers went about performing in the midst of\nthem when the man struck up with his tune.]')
    check_text('<onDraw name="myFunc" label="aaa   bbb">A paragraph')
    check_text('<para><onDraw name="myFunc" label="aaa   bbb">B paragraph</para>')
    _parser.caseSensitive = 0
    check_text('Here comes <FONT FACE="Helvetica" SIZE="14pt">Helvetica 14</FONT> with <STRONG>strong</STRONG> <EM>emphasis</EM>.')
    check_text('Here comes <font face="Helvetica" size="14pt">Helvetica 14</font> with <Strong>strong</Strong> <em>emphasis</em>.')
    check_text('Here comes <font face="Courier" size="3cm">Courier 3cm</font> and normal again.')

